Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.classifiers.rules
Class FURIA

    java.lang.Object
      weka.classifiers.AbstractClassifier
          weka.classifiers.rules.FURIA

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, Classifier, AdditionalMeasureProducer, CapabilitiesHandler, OptionHandler, RevisionHandler, TechnicalInformationHandler, WeightedInstancesHandler

    public class FURIA

extends AbstractClassifier
implements OptionHandler, AdditionalMeasureProducer, WeightedInstancesHandler, TechnicalInformationHandler

FURIA: Fuzzy Unordered Rule Induction Algorithm
Details please see:
Jens Christian Huehn, Eyke Huellermeier (2009). FURIA: An Algorithm for Unordered Fuzzy Rule Induction. Data Mining and Knowledge Discovery..

BibTeX:

     @article{Huehn2009,
        author = {Jens Christian Huehn and Eyke Huellermeier},
        journal = {Data Mining and Knowledge Discovery},
        title = {FURIA: An Algorithm for Unordered Fuzzy Rule Induction},
        year = {2009}
     }

Valid options are:

     -F <number of folds>
      Set number of folds for REP
      One fold is used as pruning set.
      (default 3)

     -N <min. weights>
      Set the minimal weights of instances
      within a split.
      (default 2.0)

     -O <number of runs>
      Set the number of runs of
      optimizations. (Default: 2)

     -D
      Set whether turn on the
      debug mode (Default: false)

     -S <seed>
      The seed of randomization
      (Default: 1)

     -E
      Whether NOT check the error rate>=0.5
      in stopping criteria  (default: check)

     -s
      The action performed for uncovered instances.
      (default: use stretching)

     -p
      The T-norm used as fuzzy AND-operator.
      (default: Product T-norm)

Version:
  $Revision: 5964 $
Author:
  Jens Christian Hühn (huehn@gmx.net), Xin Xu (xx5@cs.waikato.ac.nz), Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  Serialized Form

Nested Class Summary
`class` | `FURIA.NumericAntd` The antecedent with numeric attribute
`class` | `FURIA.RipperRule` This class implements a single rule that predicts specified class.

Constructor Summary
`FURIA()`

Method Summary
`void` | `buildClassifier(Instances instances)` Builds the FURIA rule-based model
`java.lang.String` | `checkErrorRateTipText()` Returns the tip text for this property
`java.lang.String` | `debugTipText()` Returns the tip text for this property
`double[]` | `distributionForInstance(Instance datum)` Classify the test instance with the rule learner and provide the class distributions
`java.util.Enumeration` | `enumerateMeasures()` Returns an enumeration of the additional measure names
`java.lang.String` | `foldsTipText()` Returns the tip text for this property
`Capabilities` | `getCapabilities()` Returns default capabilities of the classifier.
`boolean` | `getCheckErrorRate()` Gets whether to check for error rate is in stopping criterion
`boolean` | `getDebug()` Gets whether debug information is output to the console
`int` | `getFolds()` Gets the number of folds
`double` | `getMeasure(java.lang.String additionalMeasureName)` Returns the value of the named measure
`double` | `getMinNo()` Gets the minimum total weight of the instances in a rule
`int` | `getOptimizations()` Gets the the number of optimization runs
`java.lang.String[]` | `getOptions()` Gets the current settings of the Classifier.
`java.lang.String` | `getRevision()` Returns the revision string.
`FastVector` | `getRuleset()` Get the ruleset generated by FURIA
`RuleStats` | `getRuleStats(int pos)` Get the statistics of the ruleset in the given position
`long` | `getSeed()` Gets the current seed value to use in randomizing the data
`TechnicalInformation` | `getTechnicalInformation()` Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`SelectedTag` | `getTNorm()` Gets the TNorm used.
`SelectedTag` | `getUncovAction()` Gets the action that is performed for uncovered instances.
`java.lang.String` | `globalInfo()` Returns a string describing classifier
`java.util.Enumeration` | `listOptions()` Returns an enumeration describing the available options Valid options are:
`static void` | `main(java.lang.String[] args)` Main method.
`java.lang.String` | `minNoTipText()` Returns the tip text for this property
`java.lang.String` | `optimizationsTipText()` Returns the tip text for this property
`java.lang.String` | `seedTipText()` Returns the tip text for this property
`void` | `setCheckErrorRate(boolean d)` Sets whether to check for error rate is in stopping criterion
`void` | `setDebug(boolean d)` Sets whether debug information is output to the console
`void` | `setFolds(int fold)` Sets the number of folds to use
`void` | `setMinNo(double m)` Sets the minimum total weight of the instances in a rule
`void` | `setOptimizations(int run)` Sets the number of optimization runs
`void` | `setOptions(java.lang.String[] options)` Parses a given list of options.
`void` | `setSeed(long s)` Sets the seed value to use in randomizing the data
`void` | `setTNorm(SelectedTag newTNorm)` Sets the TNorm used.
`void` | `setUncovAction(SelectedTag newUncovAction)` Sets the action that is performed for uncovered instances.
`java.lang.String` | `TNormTipText()` Returns the tip text for this property
`java.lang.String` | `toString()` Prints the all the rules of the rule learner.
`java.lang.String` | `uncovActionTipText()` Returns the tip text for this property

Methods inherited from class weka.classifiers.AbstractClassifier
`classifyInstance, forName, makeCopies, makeCopy`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FURIA

    public FURIA()

Method Detail

### globalInfo

    public java.lang.String globalInfo()

  Returns a string describing classifier

  Returns:
    a description suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

    public TechnicalInformation getTechnicalInformation()

  Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

  Specified by:
    `getTechnicalInformation` in interface `TechnicalInformationHandler`
  Returns:
    the technical information about this class

### listOptions

    public java.util.Enumeration listOptions()

  Returns an enumeration describing the available options Valid options are:

  -F number
  The number of folds for reduced error pruning. One fold is used as the pruning set. (Default: 3)

  -N number
  The minimal weights of instances within a split. (Default: 2)

  -O number
  Set the number of runs of optimizations. (Default: 2)

  -D
  Whether turn on the debug mode -S number
  The seed of randomization used in FURIA.(Default: 1)

  -E
  Whether NOT check the error rate >= 0.5 in stopping criteria. (default: check)

  -s
  The action performed for uncovered instances. (default: use rule stretching)

  -p
  The T-Norm used as fuzzy AND-operator. (default: Product T-Norm)

  Specified by:
    `listOptions` in interface `OptionHandler`
  Overrides:
    `listOptions` in class `AbstractClassifier`
  Returns:
    an enumeration of all the available options

### setOptions

    public void setOptions(java.lang.String[] options)
                    throws java.lang.Exception

  Parses a given list of options.

  Valid options are:

       -F <number of folds>
        Set number of folds for REP
        One fold is used as pruning set.
        (default 3)

       -N <min. weights>
        Set the minimal weights of instances
        within a split.
        (default 2.0)

       -O <number of runs>
        Set the number of runs of
        optimizations. (Default: 2)

       -D
        Set whether turn on the
        debug mode (Default: false)

       -S <seed>
        The seed of randomization
        (Default: 1)

       -E
        Whether NOT check the error rate>=0.5
        in stopping criteria  (default: check)

       -s
        The action performed for uncovered instances.
        (default: use stretching)

       -p
        The T-norm used as fuzzy AND-operator.
        (default: Product T-norm)

  Specified by:
    `setOptions` in interface `OptionHandler`
  Overrides:
    `setOptions` in class `AbstractClassifier`
  Parameters:
    `options` - the list of options as an array of strings
  Throws:
    `java.lang.Exception` - if an option is not supported

### getOptions

    public java.lang.String[] getOptions()

  Gets the current settings of the Classifier.

  Specified by:
    `getOptions` in interface `OptionHandler`
  Overrides:
    `getOptions` in class `AbstractClassifier`
  Returns:
    an array of strings suitable for passing to setOptions

### enumerateMeasures

    public java.util.Enumeration enumerateMeasures()

  Returns an enumeration of the additional measure names

  Specified by:
    `enumerateMeasures` in interface `AdditionalMeasureProducer`
  Returns:
    an enumeration of the measure names

### getMeasure

    public double getMeasure(java.lang.String additionalMeasureName)

  Returns the value of the named measure

  Specified by:
    `getMeasure` in interface `AdditionalMeasureProducer`
  Parameters:
    `additionalMeasureName` - the name of the measure to query for its value
  Returns:
    the value of the named measure
  Throws:
    `java.lang.IllegalArgumentException` - if the named measure is not supported

### foldsTipText

    public java.lang.String foldsTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setFolds

    public void setFolds(int fold)

  Sets the number of folds to use

  Parameters:
    `fold` - the number of folds

### getFolds

    public int getFolds()

  Gets the number of folds

  Returns:
    the number of folds

### minNoTipText

    public java.lang.String minNoTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setMinNo

    public void setMinNo(double m)

  Sets the minimum total weight of the instances in a rule

  Parameters:
    `m` - the minimum total weight of the instances in a rule

### getMinNo

    public double getMinNo()

  Gets the minimum total weight of the instances in a rule

  Returns:
    the minimum total weight of the instances in a rule

### seedTipText

    public java.lang.String seedTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setSeed

    public void setSeed(long s)

  Sets the seed value to use in randomizing the data

  Parameters:
    `s` - the new seed value

### getSeed

    public long getSeed()

  Gets the current seed value to use in randomizing the data

  Returns:
    the seed value

### optimizationsTipText

    public java.lang.String optimizationsTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setOptimizations

    public void setOptimizations(int run)

  Sets the number of optimization runs

  Parameters:
    `run` - the number of optimization runs

### getOptimizations

    public int getOptimizations()

  Gets the the number of optimization runs

  Returns:
    the number of optimization runs

### debugTipText

    public java.lang.String debugTipText()

  Returns the tip text for this property

  Overrides:
    `debugTipText` in class `AbstractClassifier`
  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setDebug

    public void setDebug(boolean d)

  Sets whether debug information is output to the console

  Overrides:
    `setDebug` in class `AbstractClassifier`
  Parameters:
    `d` - whether debug information is output to the console

### getDebug

    public boolean getDebug()

  Gets whether debug information is output to the console

  Overrides:
    `getDebug` in class `AbstractClassifier`
  Returns:
    whether debug information is output to the console

### checkErrorRateTipText

    public java.lang.String checkErrorRateTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setCheckErrorRate

    public void setCheckErrorRate(boolean d)

  Sets whether to check for error rate is in stopping criterion

  Parameters:
    `d` - whether to check for error rate is in stopping criterion

### getCheckErrorRate

    public boolean getCheckErrorRate()

  Gets whether to check for error rate is in stopping criterion

  Returns:
    true if checking for error rate is in stopping criterion

### uncovActionTipText

    public java.lang.String uncovActionTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getUncovAction

    public SelectedTag getUncovAction()

  Gets the action that is performed for uncovered instances. It can be UNCOVACTION_STRETCH, UNCOVACTION_APRIORI or UNCOVACTION_REJECT.

  Returns:
    the current TNorm.

### setUncovAction

    public void setUncovAction(SelectedTag newUncovAction)

  Sets the action that is performed for uncovered instances. It can be UNCOVACTION_STRETCH, UNCOVACTION_APRIORI or UNCOVACTION_REJECT.

  Parameters:
    `newUncovAction` - the new action.

### TNormTipText

    public java.lang.String TNormTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getTNorm

    public SelectedTag getTNorm()

  Gets the TNorm used. Will be either TNORM_PROD or TNORM_MIN.

  Returns:
    the current TNorm.

### setTNorm

    public void setTNorm(SelectedTag newTNorm)

  Sets the TNorm used. Will be either TNORM_PROD or TNORM_MIN.

  Parameters:
    `newTNorm` - the new TNorm.

### getRuleset

    public FastVector getRuleset()

  Get the ruleset generated by FURIA

  Returns:
    the ruleset

### getRuleStats

    public RuleStats getRuleStats(int pos)

  Get the statistics of the ruleset in the given position

  Parameters:
    `pos` - the position of the stats, assuming correct
  Returns:
    the statistics of the ruleset in the given position

### getCapabilities

    public Capabilities getCapabilities()

  Returns default capabilities of the classifier.

  Specified by:
    `getCapabilities` in interface `Classifier`
  Specified by:
    `getCapabilities` in interface `CapabilitiesHandler`
  Overrides:
    `getCapabilities` in class `AbstractClassifier`
  Returns:
    the capabilities of this classifier
  See Also:
    `Capabilities`

### buildClassifier

    public void buildClassifier(Instances instances)
                         throws java.lang.Exception

  Builds the FURIA rule-based model

  Specified by:
    `buildClassifier` in interface `Classifier`
  Parameters:
    `instances` - the training data
  Throws:
    `java.lang.Exception` - if classifier can't be built successfully

### distributionForInstance

    public double[] distributionForInstance(Instance datum)
                                     throws java.lang.Exception

  Classify the test instance with the rule learner and provide the class distributions

  Specified by:
    `distributionForInstance` in interface `Classifier`
  Overrides:
    `distributionForInstance` in class `AbstractClassifier`
  Parameters:
    `datum` - the instance to be classified
  Returns:
    the distribution
  Throws:
    `java.lang.Exception`

### toString

    public java.lang.String toString()

  Prints the all the rules of the rule learner.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a textual description of the classifier

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

  Main method.

  Parameters:
    `args` - the options for the classifier
  Throws:
    `java.lang.Exception`

### getRevision

    public java.lang.String getRevision()

  Description copied from class: `AbstractClassifier`
  Returns the revision string.

  Specified by:
    `getRevision` in interface `RevisionHandler`
  Overrides:
    `getRevision` in class `AbstractClassifier`
  Returns:
    the revision

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD